// CExec.h
// Global header file for the C version of the simple array based three phase
// simulation executive
// Bs and Cs represented by function pointers

#ifndef CEXEC_H
	#define CEXEC_H
	#include "GenLib.h"

	#define MaxEnt 30                         // Don't try more than 30 entities
	#define MaxObs 100                       	// Don't try more than 100 observations
	#define MaxC 10                           // Max No of C Activities
	#define MAXINT 32767						// Needed for MS Visual C++

	typedef int Observations[MaxObs];

	struct EntDetails
	{									 	// Holds entity information
		String Name;      					// Entity name for listings
		enum Boolean Avail;         		// Indicates whether occupied
		int TimeCell;      					// TimeCell
		void (*NextB)();          			// Next B activity, if one due
		int Util;          					// Utilisation time}
	};

	// ----------------------------------------------------------------------------
	// ---------------------------  Executive functions  --------------------------
	//-----------------------------------------------------------------------------
	void Simulate(void);
	void Initialisation(void);
	void Finalisation(void);
#endif

